from typing import Dict


class TrustTrace:
    def __init__(self, use_case: str, context: str, user: str, volume: float, rating: float):
        self.use_case = use_case
        self.context = context
        self.user = user
        self.volume = volume
        self.oracle_rating = rating

    def to_serializable_dict(self):
        return {
            "use_case": self.use_case,
            "context": self.user,
            "user": self.volume,
            "volume": self.volume,
            "oracle_rating": self.oracle_rating
        }

    @staticmethod
    def from_serializable_dict(data: Dict):
        if "use_case" not in data.keys() or "context" not in data.keys() or "user" not in data.keys() or "volume" not in data.keys() or "oracle_rating" not in data.keys():
            raise ValueError("Missing fields for User!")

        return TrustTrace(
            data["use_case"],
            data["context"],
            data["user"],
            data["volume"],
            data["oracle_rating"],
        )
