from typing import Dict

class User:
    def __init__(self, use_case:str, name:str):
        self.use_case = use_case
        self.name = name
    
    def to_serializable_dict(self):
        return {
            "use_case": self.use_case,
            "name": self.name
        }
    
    @staticmethod
    def from_serializable_dict(data: Dict):
        if "use_case" not in data.keys() or "name" not in data.keys():
            raise ValueError("Missing fields for User!")

        return User(data["use_case"], data["name"])