# global imports (dont't worry, red is normal)
import network_constants as netconst
from database.MongoRepositoryBase import MongoRepositoryBase

from database.entities.user import User
from typing import List, Dict

class UserRepository(MongoRepositoryBase):
    '''This is a repository for MongoDb.'''

    def __init__(self):
        super().__init__(netconst.REPUTATION_CALCULATION_DB_HOSTNAME,
                         netconst.REPUTATION_CALCULATION_DB_PORT,
                         'rest-gateway-db')
        self._collection = 'user'

    def add(self, user: User):
        super().insert_entry(self._collection, user.to_serializable_dict())

    def all(self) -> List[Dict]:
        result = super().get_entries(self._collection, projection={'_id': False})

        return list(result)

    def all_for_use_case(self, use_case: str) -> List[Dict]:
        result = super().get_entries(self._collection, projection={'_id': False}, selection={"use_case": use_case})

        return list(result)