from database.entities.user import User
from database.repositories.user_repository import UserRepository
from flask import request, Response

user_repository: UserRepository = UserRepository()

def add(use_case: str):
    data = request.json

    user_new = None
    try:
        user_new = User.from_serializable_dict(data)
    except ValueError:
        return Response(status=400, response="Missing fields in request")
    
    if user_new.use_case != use_case:
        return Response(status = 400, response="Use-Cases in body and url do not match!")
    
    user_repository.add(user_new)

    return user_new.to_serializable_dict()

def all_for_use_case(use_case: str):
    return user_repository.all_for_use_case(use_case)
